/*******************************************************
*        Trabalho de Inteligncia Artificial           *
*             Anderson de Rezende Rocha                *
*                 Jlio Csar Alves                    * 
*******************************************************/

#ifndef MATRIZBOLL_H
#define MATRIZBOLL_H

// Classe matriz que serve para verificar se h um obstculo ou no em determinada
// posio
class clMatrizBool
{
    public:
        // Construtor da matriz
        clMatrizBool(int larg = 0, int alt = 0);
        ~clMatrizBool();
        // Cria o espao da matriz, suas propores
        void Criar(int larg, int alt);

        // Retorna se uma dada posio est ou no ocupada
        bool GetItem(int i, int j);
        // Seta uma posio da matriz para ocupada ou no
        bool SetItem(int i, int j, bool valor);
    private:
        bool *matriz;
        int largura, altura;
};

// Construtor da matriz
clMatrizBool::clMatrizBool(int larg, int alt)
{
    if(! (larg == 0 && alt == 0))
        Criar(larg, alt);
    else
        matriz = NULL;
}

// Destrutor
clMatrizBool::~clMatrizBool()
{
    delete matriz;
}

// Cria a matriz efetivamente
void clMatrizBool::Criar(int larg, int alt)
{
    if(matriz == NULL)
        delete matriz;

    largura = larg;
    altura = alt;
    matriz = new bool[largura*altura];
}

// Retorna se uma posio da matriz vinculada 'a mesma posio 
// no ambiente est ou no ocupada
bool clMatrizBool::GetItem(int i, int j)
{
    if(i >= largura || j >= altura)
    {
        cerr << "ERRO FATAL - Acesso indevido a matriz" << endl;
        return false;
    }
    else
        return matriz[largura*j+i];
}

// Seta uma posio da matriz vinculada 'a mesma posio 
// no ambiente como atualmente ocupada
bool clMatrizBool::SetItem(int i, int j, bool valor)
{
    if(i >= largura || j >= altura)
    {
        cerr << "debug - Ops, setando item indevido" << endl;
        return false;
    }
    else
        matriz[largura*j+i] = valor;
    return true;
}

#endif
