/*******************************************************
*        Trabalho de Inteligncia Artificial           *
*             Anderson de Rezende Rocha                *
*                 Jlio Csar Alves                    * 
*******************************************************/

#ifndef MINA_H
#define MINA_H

#include "ponto.h"

class clMina
{
    public:
        // Construtores da mina
        clMina();
        clMina(int idMina, clPonto pos, int quantidadeDeOuro);
        clMina(const clMina &mina);
        // Destrutor
        ~clMina();
        void operator=(const clMina &mina);

        // Retorna posio, id e quantidade de uma mina
        clPonto GetPosicao();
        int GetId();
        int GetQuantidade();

        // Verifica se uma dada mina est ou no vazia
        bool Vazia();
        // Retira uma quantidade de mineral da mina
        bool RetirarOuro(int quantidadeDeOuro = 1);

        // Verifica se uma mina  igual a outra
        bool operator==(clMina mina) { return (id == mina.id); }

    private:
        clPonto posicao;
        int id;
        int quantidade;
};

// Construtor
clMina::clMina()
{
    id = -1;
    posicao.Set(0,0);
    quantidade = 0;
}

// Destrutor
clMina::~clMina() {}

// Construindo uma mina com o identificador, posio e quantidade 
// desejados
clMina::clMina(int idMina, clPonto pos, int quantidadeDeOuro)
{
    id = idMina;
    posicao = pos;
    quantidade = quantidadeDeOuro;
}

// Construtor de cpia
clMina::clMina(const clMina &mina)
{
    id = mina.id;
    posicao = mina.posicao;
    quantidade = mina.quantidade;
}

// Permite comparar uma mina com outra
void clMina::operator=(const clMina &mina)
{
    id = mina.id;
    posicao = mina.posicao;
    quantidade = mina.quantidade;
}

// Retorna a posio desta mina no ambiente
clPonto clMina::GetPosicao()
{
    return posicao;
}

// Qual o identificador desta mina?
int clMina::GetId()
{
    return id;
}


// Qual a quantidade atual de minerio desta mina?
int clMina::GetQuantidade()
{
    return quantidade;
}

// Esta mina j est vazia?
bool clMina::Vazia()
{
    return (quantidade == 0);
}

// Quando a quantidade na mina for menor que a quantidade requisitada
// poderia retirar o que tem
bool clMina::RetirarOuro(int quantidadeDeOuro)
{
    if (quantidade >= quantidadeDeOuro)
    {
        quantidade -= quantidadeDeOuro;
        return true;
    }
    return false;
}

#endif
